The GraphiQL Working Group will begin meeting to plan work for GraphiQL. The meetings will be modelled on the GraphQL Working Group meetings, but will be less formalized as this is not a spec body, just a working group for re-building a contributor community, prioritizing every few weeks and deciding on what new features we want in GraphiQL.

- **Video Conference Link:** https://zoom.us/j/428907595
- **Live Notes:**
- **Date & Time:** May 14th 2019 16:00 - 19:00 UTC
- **NOTE:** Meeting date and time may change up to a week before the meeting. Please check the agenda the week of the meeting to confirm.

## Attendees

- Orta (@orta) - ex-Artsy
- Lee Byron (@leebyron) - GraphQL Foundation, Robin Hood
- Benjie Gillam (@benjie) - PostGraphile
- Sean Grove (@sgrove) - OneGraph Explorer
- Jake Dawkins (@JakeDawkins) - Apollo
- Trevor Scheer (@trevor-scheer) - Apollo
- Tanay Pratap (@tanaypratap) - Microsoft
- Alexey Rodionov (@FluorescentHallucinogen) - GdeZerno
- Samuel (@imolorhe) - Altair Client
- Rohit Ravikoti (@rohit-ravikoti) - Novvum
- Hyo Jeong (@asiandrummer) - Facebook
- Rikki Schulte (@acao) - Independent Maintainer

## Agenda

- Who has the npm keys? [#818](https://github.com/graphql/graphiql/issues/818)
- How will we organize/delegate work for GraphiQL WG
- Who will review work for new contributors to GraphiQL
- Should codemirror-graphql work be inclusive in the GraphiQL WG
- Should we update Contributing.md and how?
- (potentially) triage existing issues, PRs
- (potentially) decide on what needs to be accomplished before beginning new UI design
- (from Hyo) Transferring ownership to GraphQL foundation

## Outcomes

- GraphiQL 1.0 rearchitecture: will ship with a plugin system, and a leaner query tool as it's base
- Design / Architecture discussions and concrete decisions will continue to occur in github issues for GraphiQL, and ad-hoc WG meetings as necessary
- Decided on new contributing guidelines:
  - Every PR should have at least one peer review before merge (enforced via github config)
  - This review should not come from a member of the same company
  - Rebase and merge should be used, squash if necessary. Multiple individual commits for review changes, requested changes, or to split up a major PR make sense.
  - Clean git history is preferred
  - As much automation as possible will be provided to minimize the review effort
  - Hyo reminded us that performance and large-scale concerns are important. Performance impact should always be a consideration.
- Contributing.md will be updated to reflect these guidelines
- We would like to propose to the GraphQL Foundation itself that the group be renamed and/or our scope be redefined to be for all GraphQL ide tooling. Thus the "GraphQL IDE Tooling WG" or "GraphQL Tooling WG". We would like to be responsible for `codemirror-graphql` and `graphql-language-services`.
- We will prepare a prioritized list of technical debt items for contributors to work on.
  - A GH label for this perhaps?
